// Generated by CoffeeScript 1.10.0
var Utility;

Utility = (function() {
  function Utility() {}

  Utility.prototype.slice = function(buffer, begin, end) {
    if (end == null) {
      end = begin + 1;
    }
    return JSON.stringify((JSON.parse(JSON.stringify(buffer.slice(begin, end)))).data);
  };

  Utility.prototype.sliceTrim = function(buffer, begin, end) {
    var nullIndex, subBuffer;
    if (end == null) {
      end = begin + 1;
    }
    subBuffer = buffer.slice(begin, end);
    nullIndex = Array.prototype.indexOf.call(subBuffer, 0);
    if (nullIndex > -1) {
      subBuffer = subBuffer.slice(0, nullIndex);
    }
    return subBuffer;
  };

  Utility.prototype.readVector3LE = function(buffer, offset) {
    var x, y, z;
    x = buffer.readFloatLE(offset + 0);
    y = buffer.readFloatLE(offset + 4);
    z = buffer.readFloatLE(offset + 8);
    return [x, y, z];
  };

  Utility.prototype.readVector4LE = function(buffer, offset) {
    var w, x, y, z;
    x = buffer.readFloatLE(offset + 0);
    y = buffer.readFloatLE(offset + 4);
    z = buffer.readFloatLE(offset + 8);
    w = buffer.readFloatLE(offset + 12);
    return [x, y, z, w];
  };

  Utility.prototype.getBezier = function(bezier) {
    var NOOP, r, x, y, z;
    x = {};
    y = {};
    z = {};
    r = {};
    x.x1 = bezier[0], y.x1 = bezier[1], z.x1 = bezier[2], r.x1 = bezier[3], x.y1 = bezier[4], y.y1 = bezier[5], z.y1 = bezier[6], r.y1 = bezier[7], x.x2 = bezier[8], y.x2 = bezier[9], z.x2 = bezier[10], r.x2 = bezier[11], x.y2 = bezier[12], y.y2 = bezier[13], z.y2 = bezier[14], r.y2 = bezier[15], y.x1 = bezier[16], z.x1 = bezier[17], r.x1 = bezier[18], x.y1 = bezier[19], y.y1 = bezier[20], z.y1 = bezier[21], r.y1 = bezier[22], x.x2 = bezier[23], y.x2 = bezier[24], z.x2 = bezier[25], r.x2 = bezier[26], x.y2 = bezier[27], y.y2 = bezier[28], z.y2 = bezier[29], r.y2 = bezier[30], NOOP = bezier[31], z.x1 = bezier[32], r.x1 = bezier[33], x.y1 = bezier[34], y.y1 = bezier[35], z.y1 = bezier[36], r.y1 = bezier[37], x.x2 = bezier[38], y.x2 = bezier[39], z.x2 = bezier[40], r.x2 = bezier[41], x.y2 = bezier[42], y.y2 = bezier[43], z.y2 = bezier[44], r.y2 = bezier[45], NOOP = bezier[46], NOOP = bezier[47], r.x1 = bezier[48], x.y1 = bezier[49], y.y1 = bezier[50], z.y1 = bezier[51], r.y1 = bezier[52], x.x2 = bezier[53], y.x2 = bezier[54], z.x2 = bezier[55], r.x2 = bezier[56], x.y2 = bezier[57], y.y2 = bezier[58], z.y2 = bezier[59], r.y2 = bezier[60], NOOP = bezier[61], NOOP = bezier[62], NOOP = bezier[63];
    return {
      x: x,
      y: y,
      z: z,
      r: r
    };
  };

  Utility.prototype.getBezierCamera = function(bezier) {
    var l, r, v, x, y, z;
    x = {};
    y = {};
    z = {};
    r = {};
    l = {};
    v = {};
    x.x1 = bezier[0], x.x2 = bezier[1], x.y1 = bezier[2], x.y2 = bezier[3], y.x1 = bezier[4], y.x2 = bezier[5], y.y1 = bezier[6], y.y2 = bezier[7], z.x1 = bezier[8], z.x2 = bezier[9], z.y1 = bezier[10], z.y2 = bezier[11], r.x1 = bezier[12], r.x2 = bezier[13], r.y1 = bezier[14], r.y2 = bezier[15], l.x1 = bezier[16], l.x2 = bezier[17], l.y1 = bezier[18], l.y2 = bezier[19], v.x1 = bezier[20], v.x2 = bezier[21], v.y1 = bezier[22], v.y2 = bezier[23];
    return {
      x: x,
      y: y,
      z: z,
      r: r,
      l: l,
      v: v
    };
  };

  return Utility;

})();

module.exports = new Utility;

module.exports.Utility = Utility;
